/*
** Module   : XDocument
** Abstract : DOM XML Document resource type interface.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- -----------------------Description------------------------
** 001 EVL 20130130 Created initial version.
*/

package com.goldencode.p2j.xml;

import org.w3c.dom.*;
import com.goldencode.p2j.util.*;

/**
 */
public interface XDocument
extends XEntity
{
   // Methods
   // Returning value placed into hChild
   public logical createNode(handle hChild, String name, String type);
   
   public logical createNode(handle hChild, character name, String type);
   
   public logical createNode(handle hChild, String name, character type);
   
   public logical createNode(handle hChild, character name, character type);

   public logical createNodeNamespace(handle hChild, String uri,
                                      String name, String type);
   
   public logical createNodeNamespace(handle hChild, character uri,
                                      String name, String type);
   
   public logical createNodeNamespace(handle hChild, String uri,
                                      character name, String type);
   
   public logical createNodeNamespace(handle hChild, String uri,
                                      String name, character type);
   
   public logical createNodeNamespace(handle hChild, String uri,
                                      character name, character type);
   
   public logical createNodeNamespace(handle hChild, character uri,
                                      String name, character type);
   
   public logical createNodeNamespace(handle hChild, character uri,
                                      character name, String type);
   
   public logical createNodeNamespace(handle hChild, character uri,
                                      character name, character type);
   
   // Returning value placed into hRoot
   public logical getDocumentElement(handle hRoot);
   
   public logical load(String mode, Object source, logical validate);
   
   public logical load(String mode, Object source, boolean validate);
   
   public logical load(character mode, Object source, boolean validate);
   
   public logical load(character mode, Object source, logical validate);
   
   public logical save(String mode, Object target);

   public logical save(character mode, Object target);
}
