/*
** Module   : XEntityImpl
** Abstract : DOM XML document and nodereference commons implementation.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- -----------------------Description------------------------
** 001 EVL 20130130 Created initial version.
*/

package com.goldencode.p2j.xml;

import java.util.*;
import org.w3c.dom.*;
import com.goldencode.p2j.util.*;

/**
 */
public class XEntityImpl
implements XEntity
{
   
   private handle hXEntity = null;

   /** List of child node names */
   protected Map<handle, character> childNodeNameList;

   /** List of child node names */
   protected Map<handle, character> childNodeTypeList;

   /**
    * Default constructor.
    */
   public XEntityImpl()
   {
      hXEntity = new handle();
      
      childNodeNameList  = Collections.synchronizedMap(new LinkedHashMap<handle, character>());
      childNodeTypeList  = Collections.synchronizedMap(new LinkedHashMap<handle, character>());
   }

   public XEntityImpl(WrappedResource value)
   {
      this();
      hXEntity.assign(value);
   }

   public handle getHandle()
   {
      return hXEntity;
   }
   
   /**
    * Reports if this object is valid for use.  
    *
    * @return   <code>true</code> if we are valid (can be used).
    */
   public boolean isValid()
   {
      return hXEntity != null;
   }
   
   /**
    * Reports if this object is unknown.  
    *
    * @return   <code>true</code> if object is unknown.
    */
   public boolean isUnknown()
   {
      return hXEntity == null;
   }

   // Attributes
   public integer getNumChildren()
   {
      integer intRes = new integer();
      
      return intRes;
   }

   public integer getUniqId()
   {
      integer intRes = new integer();
      
      return intRes;
   }

   // Methods
   public logical appendChild(handle hChild)
   {
      return appendChild(hChild, (character) null, (character) null);
   }

   public logical appendChild(handle hChild, character name, character type)
   {
      logical res = new logical(true);
      
      childNodeNameList.put(hChild, name);
      childNodeTypeList.put(hChild, type);
      
      return res;
   }

   // Returning value placed into hChild
   public logical getChild(handle hChild, int index)
   {
      return getChild(hChild, new integer(index));
   }
   
   public logical getChild(handle hChild, integer index)
   {
      logical res = new logical(false);
      
      return res;
   }
   
   public logical removeChild(handle hChild)
   {
      logical res = new logical(false);
      
      return res;
   }
   
   public void clear()
   {
      childNodeNameList.clear();
      childNodeTypeList.clear();
      hXEntity = null;
   }
}
