/*
** Module   : XNodeRef
** Abstract : DOM XML Node reference resource type interface.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- -----------------------Description------------------------
** 001 EVL 20130130 Created initial version.
*/

package com.goldencode.p2j.xml;

import org.w3c.dom.*;
import com.goldencode.p2j.util.*;

/**
 */
public interface XNodeRef
extends XEntity
{
   // Attributes
   public character getAttributeNames();
   
   public handle getOwnerDocument();
   
   // Methods
   public logical deleteNode();
   
   public character getAttribute(String name);
   
   public character getAttribute(character name);
   
   public logical setAttribute(String name, String value);

   public logical setAttribute(String name, character value);

   public logical setAttribute(character name, String value);

   public logical setAttribute(character name, character value);
}
